// IQ_132 - HTTP://NEOSOURCE.1EMU.NET/
// Licensed under the WTFPL (http://sam.zoy.org/wtfpl/) with a single 
// additional stipulation -- this code cannot be used for profit.

#include <stdio.h>
#include <windows.h> // Not linux friendly and I don't care.

#define getlong(tab, a)	\
	((tab[a] << 24) | (tab[a+1] << 16) | (tab[a+2] << 8) | (tab[a+3] << 0))

#define getshort(tab, a) \
	((tab[a] << 8) | (tab[a+1]))

int main()
{
	FILE *fz;
	unsigned int nLen;
	unsigned char *src;
	char input_name[256];

	printf ("Please type the name of the archive file you wish to extract:\n");
	gets (input_name);
	printf ("\n");

	fz = fopen(input_name, "rb");
	if (!fz) {
		printf ("%s not found!\n", input_name);
		system ("PAUSE");
		return 1;
	}

	fseek (fz, 0, SEEK_END);
	nLen = ftell (fz);
	rewind (fz);

	src = (unsigned char*)malloc( nLen );

	fread (src, 1, nLen, fz);
	fclose (fz);

	if (getlong(src,0) != 0x55AA382D && getlong(src,4) != 0x00000020)
	{
		printf ("Not a proper archive file.\n");
		free (src);
		system ("PAUSE");
		return 1;
	}

	unsigned int data_offset   = getlong(src, 0x0c);
	unsigned int table_entries = getlong(src, 0x28) - 1;
	unsigned int ftable_flags  = getlong(src, 0x2c);

	unsigned int nStart = 0x2c;
	unsigned int string_offset = nStart + table_entries * 12;

	{
		int i;
		for (i = 0; i < strlen(input_name); i++) {
			if (input_name[i] == '.') input_name[i] = '_';
		}
	}

	char outname[512];
	char rootname[128];
	char dirname0[128];
	char dirname1[128];
	char fname[128];

	memset (outname,  0, 512);
	memset (rootname, 0, 128);
	memset (dirname0, 0, 128);
	memset (dirname1, 0, 128);
	memset (fname,    0, 128);

	int kr = table_entries;
	unsigned char *tptr = src + nStart;
	unsigned char *sptr = src + string_offset;

	while (kr > 0)
	{
		unsigned short data_flags = getshort(tptr, 0);
		unsigned short name_offs  = getshort(tptr, 2);

		unsigned int data_offs    = getlong(tptr, 4);
		unsigned int data_len     = getlong(tptr, 8);

		tptr += 12;

		int i = 0;
		while (1)
		{
			if (sptr[name_offs + i] != 0) {
				fname[i] = sptr[name_offs + i];
			} else {
				fname[i] = '\0';
				break;
			}
			i++;
		}

		kr--;

		if (data_flags & 0x0100)	// Directory
		{
			switch (data_offs)
			{
				case 0x00:	// Root directory
					strcpy (rootname, fname);
				break;

				case 0x01:	// Main directory
					strcpy (dirname0, fname);
					memset (dirname1, 0, 128);
				break;

				case 0x99:	// Sub directory
				case 0xfc:
					if (dirname0[0]) {
						strcpy (dirname1, fname);
					}
				break;
			}

			continue;
		}

		memset (outname, 0, 512);

		if (rootname[0]) {
			strcat (outname, rootname);
		} else {
			strcat (outname, input_name);
		}
		strcat (outname, "\\");
		CreateDirectory(outname, NULL);

		if (dirname0[0]) {
			strcat (outname, dirname0);
			strcat (outname, "\\");
			CreateDirectory(outname, NULL);

			if (dirname1[0]) {
				strcat (outname, dirname1);
				strcat (outname, "\\");
				CreateDirectory(outname, NULL);
			}
		}
		
		strcat (outname, fname);

		printf ("Writing %s\n", outname);

		fz = fopen(outname, "wb");
		if ((data_offs + data_len) <= nLen) {
			fwrite (src + data_offs, 1, data_len, fz);
		}

		fclose (fz);
	}

	printf ("Finished\n");
	system ("PAUSE");

	free (src);
}

